diff --git a/libglusterfs/src/fd.c b/libglusterfs/src/fd.c
index 768a2b7a0fe..07fd37e88c4 100644
--- a/libglusterfs/src/fd.c
+++ b/libglusterfs/src/fd.c
@@ -939,41 +939,38 @@ fd_ctx_get(fd_t *fd, xlator_t *xlator)
     return ret;
 }
 
-static int
-__fd_ctx_del(fd_t *fd, xlator_t *xlator, uint64_t *value)
+static uint64_t
+__fd_ctx_del(fd_t *fd, xlator_t *xlator)
 {
     int index = 0;
+    uint64_t value = 0;
 
     if (!fd || !xlator)
         return -1;
 
     for (index = 0; index < fd->xl_count; index++) {
         if (fd->_ctx[index].xl_key == xlator) {
-            if (value)
-                *value = fd->_ctx[index].value1;
+            value = fd->_ctx[index].value1;
             fd->_ctx[index].key = 0;
             fd->_ctx[index].value1 = 0;
-            return 0;
         }
     }
 
-    return -1;
+    return value;
 }
 
-int
-fd_ctx_del(fd_t *fd, xlator_t *xlator, uint64_t *value)
+uint64_t
+fd_ctx_del(fd_t *fd, xlator_t *xlator)
 {
-    int ret = 0;
-
-    if (!fd)
-        return -1;
+    uint64_t ret = 0;
 
-    LOCK(&fd->lock);
-    {
-        ret = __fd_ctx_del(fd, xlator, value);
+    if (fd) {
+        LOCK(&fd->lock);
+        {
+            ret = __fd_ctx_del(fd, xlator);
+        }
+        UNLOCK(&fd->lock);
     }
-    UNLOCK(&fd->lock);
-
     return ret;
 }
 
diff --git a/libglusterfs/src/glusterfs/fd.h b/libglusterfs/src/glusterfs/fd.h
index 6a78e627c70..362d85ef112 100644
--- a/libglusterfs/src/glusterfs/fd.h
+++ b/libglusterfs/src/glusterfs/fd.h
@@ -143,8 +143,8 @@ fd_ctx_set(fd_t *fd, xlator_t *xlator, uint64_t value);
 uint64_t
 fd_ctx_get(fd_t *fd, xlator_t *xlator);
 
-int
-fd_ctx_del(fd_t *fd, xlator_t *xlator, uint64_t *value);
+uint64_t
+fd_ctx_del(fd_t *fd, xlator_t *xlator);
 
 int
 __fd_ctx_set(fd_t *fd, xlator_t *xlator, uint64_t value);
diff --git a/xlators/cluster/afr/src/afr-common.c b/xlators/cluster/afr/src/afr-common.c
index e63ae3927cd..4ac3f118cf9 100644
--- a/xlators/cluster/afr/src/afr-common.c
+++ b/xlators/cluster/afr/src/afr-common.c
@@ -4122,7 +4122,6 @@ static afr_fd_ctx_t *
 __afr_fd_ctx_get(fd_t *fd, xlator_t *this)
 {
     uint64_t ctx = 0;
-    int ret = 0;
     afr_fd_ctx_t *fd_ctx = NULL;
 
     ctx = __fd_ctx_get(fd, this);
diff --git a/xlators/cluster/dht/src/dht-helper.c b/xlators/cluster/dht/src/dht-helper.c
index 6791021b15f..ca5d36b1e2a 100644
--- a/xlators/cluster/dht/src/dht-helper.c
+++ b/xlators/cluster/dht/src/dht-helper.c
@@ -28,8 +28,8 @@ dht_fd_ctx_destroy(xlator_t *this, fd_t *fd)
     GF_VALIDATE_OR_GOTO("dht", this, out);
     GF_VALIDATE_OR_GOTO(this->name, fd, out);
 
-    ret = fd_ctx_del(fd, this, &value);
-    if (ret) {
+    value = fd_ctx_del(fd, this);
+    if (!value) {
         goto out;
     }
 
@@ -114,7 +114,6 @@ static dht_fd_ctx_t *
 dht_fd_ctx_get(xlator_t *this, fd_t *fd)
 {
     dht_fd_ctx_t *fd_ctx = NULL;
-    int ret = -1;
     uint64_t tmp_val = 0;
 
     GF_VALIDATE_OR_GOTO("dht", this, out);
@@ -123,14 +122,11 @@ dht_fd_ctx_get(xlator_t *this, fd_t *fd)
     LOCK(&fd->lock);
     {
         tmp_val = __fd_ctx_get(fd, this);
-        if (tmp_val == 0) {
-            goto unlock;
+        if (tmp_val) {
+            fd_ctx = (dht_fd_ctx_t *)(uintptr_t)tmp_val;
+            GF_REF_GET(fd_ctx);
         }
-
-        fd_ctx = (dht_fd_ctx_t *)(uintptr_t)tmp_val;
-        GF_REF_GET(fd_ctx);
     }
-unlock:
     UNLOCK(&fd->lock);
 
 out:
diff --git a/xlators/cluster/ec/src/ec.c b/xlators/cluster/ec/src/ec.c
index 39753b3a560..118324b8f66 100644
--- a/xlators/cluster/ec/src/ec.c
+++ b/xlators/cluster/ec/src/ec.c
@@ -1502,7 +1502,8 @@ ec_gf_release_fd(xlator_t *this, fd_t *fd)
     uint64_t value = 0;
     ec_fd_t *ctx = NULL;
 
-    if ((fd_ctx_del(fd, this, &value) == 0) && (value != 0)) {
+    value = fd_ctx_del(fd, this);
+    if (value) {
         ctx = (ec_fd_t *)(uintptr_t)value;
         loc_wipe(&ctx->loc);
         GF_FREE(ctx);
diff --git a/xlators/features/bit-rot/src/stub/bit-rot-stub-helpers.c b/xlators/features/bit-rot/src/stub/bit-rot-stub-helpers.c
index 1a47b89f5ee..2a4866ebd7a 100644
--- a/xlators/features/bit-rot/src/stub/bit-rot-stub-helpers.c
+++ b/xlators/features/bit-rot/src/stub/bit-rot-stub-helpers.c
@@ -45,16 +45,13 @@ __br_stub_fd_ctx_get(xlator_t *this, fd_t *fd)
 {
     br_stub_fd_t *br_stub_fd = NULL;
     uint64_t value = 0;
-    int ret = -1;
 
     GF_VALIDATE_OR_GOTO("bit-rot-stub", this, out);
     GF_VALIDATE_OR_GOTO(this->name, fd, out);
 
     value = __fd_ctx_get(fd, this);
-    if (!value)
-        return NULL;
-
-    br_stub_fd = (br_stub_fd_t *)((long)value);
+    if (value)
+        br_stub_fd = (br_stub_fd_t *)((long)value);
 
 out:
     return br_stub_fd;
diff --git a/xlators/features/bit-rot/src/stub/bit-rot-stub.c b/xlators/features/bit-rot/src/stub/bit-rot-stub.c
index 64ad884867a..655a071e24a 100644
--- a/xlators/features/bit-rot/src/stub/bit-rot-stub.c
+++ b/xlators/features/bit-rot/src/stub/bit-rot-stub.c
@@ -3452,7 +3452,7 @@ br_stub_release(xlator_t *this, fd_t *fd)
         br_stub_send_ipc_fop(this, fd, releaseversion, signinfo);
     }
 
-    ret = fd_ctx_del(fd, this, &tmp);
+    tmp = fd_ctx_del(fd, this);
     br_stub_fd = (br_stub_fd_t *)(long)tmp;
 
     GF_FREE(br_stub_fd);
@@ -3467,8 +3467,8 @@ br_stub_releasedir(xlator_t *this, fd_t *fd)
     uint64_t ctx = 0;
     int ret = 0;
 
-    ret = fd_ctx_del(fd, this, &ctx);
-    if (ret < 0)
+    ctx = fd_ctx_del(fd, this);
+    if (!ctx)
         goto out;
 
     fctx = (br_stub_fd_t *)(long)ctx;
diff --git a/xlators/features/changelog/src/changelog.c b/xlators/features/changelog/src/changelog.c
index b1ba0211760..effcd4cd99a 100644
--- a/xlators/features/changelog/src/changelog.c
+++ b/xlators/features/changelog/src/changelog.c
@@ -1885,7 +1885,7 @@ changelog_release(xlator_t *this, fd_t *fd)
     gf_uuid_copy(ev.u.release.gfid, fd->inode->gfid);
     changelog_dispatch_event(this, priv, &ev);
 
-    (void)fd_ctx_del(fd, this, NULL);
+    (void)fd_ctx_del(fd, this);
 
     return 0;
 }
diff --git a/xlators/features/index/src/index.c b/xlators/features/index/src/index.c
index e7644ee1dbd..af334049ee4 100644
--- a/xlators/features/index/src/index.c
+++ b/xlators/features/index/src/index.c
@@ -2571,8 +2571,8 @@ index_releasedir(xlator_t *this, fd_t *fd)
     uint64_t ctx = 0;
     int ret = 0;
 
-    ret = fd_ctx_del(fd, this, &ctx);
-    if (ret < 0)
+    ctx = fd_ctx_del(fd, this);
+    if (!ctx)
         goto out;
 
     fctx = (index_fd_ctx_t *)(long)ctx;
@@ -2593,15 +2593,13 @@ index_release(xlator_t *this, fd_t *fd)
 {
     index_fd_ctx_t *fctx = NULL;
     uint64_t ctx = 0;
-    int ret = 0;
 
-    ret = fd_ctx_del(fd, this, &ctx);
-    if (ret < 0)
-        goto out;
+    ctx = fd_ctx_del(fd, this);
+    if (ctx) {
+        fctx = (index_fd_ctx_t *)(long)ctx;
+        GF_FREE(fctx);
+    }
 
-    fctx = (index_fd_ctx_t *)(long)ctx;
-    GF_FREE(fctx);
-out:
     return 0;
 }
 
diff --git a/xlators/features/leases/src/leases.c b/xlators/features/leases/src/leases.c
index 85cc5a4df05..4ec72a03d55 100644
--- a/xlators/features/leases/src/leases.c
+++ b/xlators/features/leases/src/leases.c
@@ -1065,8 +1065,8 @@ leases_release(xlator_t *this, fd_t *fd)
 
     gf_log(this->name, GF_LOG_TRACE, "Releasing all leases with fd %p", fd);
 
-    ret = fd_ctx_del(fd, this, &tmp);
-    if (ret) {
+    tmp = fd_ctx_del(fd, this);
+    if (!tmp) {
         gf_log(this->name, GF_LOG_DEBUG, "Could not get fdctx");
         goto out;
     }
diff --git a/xlators/features/locks/src/posix.c b/xlators/features/locks/src/posix.c
index e69e6717083..d69ae67efdf 100644
--- a/xlators/features/locks/src/posix.c
+++ b/xlators/features/locks/src/posix.c
@@ -2996,9 +2996,10 @@ pl_release(xlator_t *this, fd_t *fd)
     pl_update_refkeeper(this, fd->inode);
 
 clean:
-    ret = fd_ctx_del(fd, this, &tmp);
-    if (ret) {
+    tmp = fd_ctx_del(fd, this);
+    if (!tmp) {
         gf_log(this->name, GF_LOG_DEBUG, "Could not get fdctx");
+        ret = -1;
         goto out;
     }
 
@@ -3020,8 +3021,8 @@ pl_releasedir(xlator_t *this, fd_t *fd)
         goto out;
     }
 
-    ret = fd_ctx_del(fd, this, &tmp);
-    if (ret) {
+    tmp = fd_ctx_del(fd, this);
+    if (!tmp) {
         gf_log(this->name, GF_LOG_DEBUG, "Could not get fdctx");
         goto out;
     }
@@ -3029,6 +3030,7 @@ pl_releasedir(xlator_t *this, fd_t *fd)
     fdctx = (pl_fdctx_t *)(long)tmp;
 
     GF_FREE(fdctx);
+    ret = 0;
 out:
     return ret;
 }
diff --git a/xlators/features/snapview-client/src/snapview-client.c b/xlators/features/snapview-client/src/snapview-client.c
index 5259627cc13..1ccb59cf46b 100644
--- a/xlators/features/snapview-client/src/snapview-client.c
+++ b/xlators/features/snapview-client/src/snapview-client.c
@@ -2400,13 +2400,12 @@ gf_svc_releasedir(xlator_t *this, fd_t *fd)
 {
     svc_fd_t *sfd = NULL;
     uint64_t tmp_pfd = 0;
-    int ret = 0;
 
     GF_VALIDATE_OR_GOTO("snapview-client", this, out);
     GF_VALIDATE_OR_GOTO(this->name, fd, out);
 
-    ret = fd_ctx_del(fd, this, &tmp_pfd);
-    if (ret < 0) {
+    tmp_pfd = fd_ctx_del(fd, this);
+    if (!tmp_pfd) {
         gf_msg_debug(this->name, 0, "pfd from fd=%p is NULL", fd);
         goto out;
     }
diff --git a/xlators/features/snapview-server/src/snapview-server.c b/xlators/features/snapview-server/src/snapview-server.c
index 38f11437652..a193be150a8 100644
--- a/xlators/features/snapview-server/src/snapview-server.c
+++ b/xlators/features/snapview-server/src/snapview-server.c
@@ -1224,9 +1224,10 @@ svs_releasedir(xlator_t *this, fd_t *fd)
     GF_VALIDATE_OR_GOTO("snapview-server", this, out);
     GF_VALIDATE_OR_GOTO(this->name, fd, out);
 
-    ret = fd_ctx_del(fd, this, &tmp_pfd);
-    if (ret < 0) {
+    tmp_pfd = fd_ctx_del(fd, this);
+    if (tmp_pfd == 0) {
         gf_msg_debug(this->name, 0, "pfd from fd=%p is NULL", fd);
+        ret = -1;
         goto out;
     }
 
@@ -1261,7 +1262,6 @@ svs_flush(call_frame_t *frame, xlator_t *this, fd_t *fd, dict_t *xdata)
 {
     int32_t op_ret = -1;
     int32_t op_errno = 0;
-    int ret = -1;
     uint64_t value = 0;
     svs_inode_t *inode_ctx = NULL;
     call_stack_t *root = NULL;
@@ -1318,9 +1318,10 @@ svs_release(xlator_t *this, fd_t *fd)
     GF_VALIDATE_OR_GOTO("snapview-server", this, out);
     GF_VALIDATE_OR_GOTO(this->name, fd, out);
 
-    ret = fd_ctx_del(fd, this, &tmp_pfd);
-    if (ret < 0) {
+    tmp_pfd = fd_ctx_del(fd, this);
+    if (tmp_pfd) {
         gf_msg_debug(this->name, 0, "pfd from fd=%p is NULL", fd);
+        ret = -1;
         goto out;
     }
 
diff --git a/xlators/mount/fuse/src/fuse-bridge.c b/xlators/mount/fuse/src/fuse-bridge.c
index 64d55a6f7fe..447b400359f 100644
--- a/xlators/mount/fuse/src/fuse-bridge.c
+++ b/xlators/mount/fuse/src/fuse-bridge.c
@@ -126,11 +126,10 @@ fuse_fd_ctx_destroy(xlator_t *this, fd_t *fd)
 {
     fd_t *activefd = NULL;
     uint64_t val = 0;
-    int ret = 0;
     fuse_fd_ctx_t *fdctx = NULL;
 
-    ret = fd_ctx_del(fd, this, &val);
-    if (!ret) {
+    val = fd_ctx_del(fd, this);
+    if (val) {
         fdctx = (fuse_fd_ctx_t *)(unsigned long)val;
         if (fdctx) {
             activefd = fdctx->activefd;
diff --git a/xlators/performance/read-ahead/src/read-ahead.c b/xlators/performance/read-ahead/src/read-ahead.c
index 983a81cbb28..131af6ff6b5 100644
--- a/xlators/performance/read-ahead/src/read-ahead.c
+++ b/xlators/performance/read-ahead/src/read-ahead.c
@@ -234,14 +234,13 @@ int
 ra_release(xlator_t *this, fd_t *fd)
 {
     uint64_t tmp_file = 0;
-    int ret = 0;
 
     GF_VALIDATE_OR_GOTO("read-ahead", this, out);
     GF_VALIDATE_OR_GOTO(this->name, fd, out);
 
-    ret = fd_ctx_del(fd, this, &tmp_file);
+    tmp_file = fd_ctx_del(fd, this);
 
-    if (!ret) {
+    if (tmp_file) {
         ra_file_destroy((ra_file_t *)(long)tmp_file);
     }
 
diff --git a/xlators/performance/readdir-ahead/src/readdir-ahead.c b/xlators/performance/readdir-ahead/src/readdir-ahead.c
index 0377fabd5e3..0f0d96a70d6 100644
--- a/xlators/performance/readdir-ahead/src/readdir-ahead.c
+++ b/xlators/performance/readdir-ahead/src/readdir-ahead.c
@@ -1123,7 +1123,8 @@ rda_releasedir(xlator_t *this, fd_t *fd)
     uint64_t val;
     struct rda_fd_ctx *ctx;
 
-    if (fd_ctx_del(fd, this, &val) < 0)
+    val = fd_ctx_del(fd, this);
+    if (val == 0)
         return -1;
 
     ctx = (struct rda_fd_ctx *)(uintptr_t)val;
diff --git a/xlators/performance/write-behind/src/write-behind.c b/xlators/performance/write-behind/src/write-behind.c
index e282d5b9b49..93ac80fb4fd 100644
--- a/xlators/performance/write-behind/src/write-behind.c
+++ b/xlators/performance/write-behind/src/write-behind.c
@@ -2770,9 +2770,7 @@ wb_forget(xlator_t *this, inode_t *inode)
 int
 wb_release(xlator_t *this, fd_t *fd)
 {
-    uint64_t tmp = 0;
-
-    (void)fd_ctx_del(fd, this, &tmp);
+    (void)fd_ctx_del(fd, this);
 
     return 0;
 }
diff --git a/xlators/protocol/client/src/client-helpers.c b/xlators/protocol/client/src/client-helpers.c
index 38432185664..343a7c32290 100644
--- a/xlators/protocol/client/src/client-helpers.c
+++ b/xlators/protocol/client/src/client-helpers.c
@@ -44,17 +44,12 @@ client_fd_lk_list_empty(fd_lk_ctx_t *lk_ctx, gf_boolean_t try_lock)
 clnt_fd_ctx_t *
 this_fd_del_ctx(fd_t *file, xlator_t *this)
 {
-    int dict_ret = -1;
     uint64_t ctxaddr = 0;
 
     GF_VALIDATE_OR_GOTO("client", this, out);
     GF_VALIDATE_OR_GOTO(this->name, file, out);
 
-    dict_ret = fd_ctx_del(file, this, &ctxaddr);
-
-    if (dict_ret < 0) {
-        ctxaddr = 0;
-    }
+    ctxaddr = fd_ctx_del(file, this);
 
 out:
     return (clnt_fd_ctx_t *)(unsigned long)ctxaddr;
diff --git a/xlators/storage/posix/src/posix-inode-fd-ops.c b/xlators/storage/posix/src/posix-inode-fd-ops.c
index 34694165bb0..30960b24855 100644
--- a/xlators/storage/posix/src/posix-inode-fd-ops.c
+++ b/xlators/storage/posix/src/posix-inode-fd-ops.c
@@ -1431,13 +1431,12 @@ posix_releasedir(xlator_t *this, fd_t *fd)
 {
     struct posix_fd *pfd = NULL;
     uint64_t tmp_pfd = 0;
-    int ret = 0;
 
     VALIDATE_OR_GOTO(this, out);
     VALIDATE_OR_GOTO(fd, out);
 
-    ret = fd_ctx_del(fd, this, &tmp_pfd);
-    if (ret < 0) {
+    tmp_pfd = fd_ctx_del(fd, this);
+    if (tmp_pfd == 0) {
         gf_msg_debug(this->name, 0, "pfd from fd=%p is NULL", fd);
         goto out;
     }
@@ -2651,7 +2650,6 @@ int32_t
 posix_release(xlator_t *this, fd_t *fd)
 {
     struct posix_fd *pfd = NULL;
-    int ret = -1;
     uint64_t tmp_pfd = 0;
 
     VALIDATE_OR_GOTO(this, out);
@@ -2660,8 +2658,8 @@ posix_release(xlator_t *this, fd_t *fd)
     if (fd->inode->active_fd_count == 0)
         posix_unlink_renamed_file(this, fd->inode);
 
-    ret = fd_ctx_del(fd, this, &tmp_pfd);
-    if (ret < 0) {
+    tmp_pfd = fd_ctx_del(fd, this);
+    if (tmp_pfd == 0) {
         gf_msg(this->name, GF_LOG_WARNING, 0, P_MSG_PFD_NULL,
                "pfd is NULL from fd=%p", fd);
         goto out;
